/***************************************************************************
                          sbmpfont.cpp  -  description
                             -------------------
    begin                : Mon Dec 23 2002
    copyright            : (C) 2002 by Andre Stein
    email                : andre_stein@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "sbmpfont.h"
#include <string.h>

SBMPFont::SBMPFont()
{
        lists = 0;
}

SBMPFont::~SBMPFont()
{
        if (lists)
                glDeleteLists(lists,256);
}

/** No descriptions */
void SBMPFont::init()
{
        texture.createTexture("data/font.bmp");

        /** Build font **/

        float x,y;

        lists = glGenLists(256);
        texture.select();

        for (int i = 0; i < 256; ++i)
        {
                x = float(i % 16)/16.0f;
		y = float(i / 16)/16.0f;

                glNewList(lists + i,GL_COMPILE);
                        glBegin(GL_QUADS);
				glTexCoord2f(x,1-y-0.0625f);			
				glVertex2i(0,0);
				glTexCoord2f(x+0.0625f,1-y-0.0625f);	
				glVertex2i(16,0);			
				glTexCoord2f(x+0.0625f,1-y);		
				glVertex2i(16,16);			
				glTexCoord2f(x,1-y);			
				glVertex2i(0,16);			
			glEnd();					
			glTranslatef(10.0f,0.0f,0.0f);				
		glEndList();	
                
        }
        
        //done.
}
/** No descriptions */
void SBMPFont::printAt(float x, float y, const char* text, bool italic)
{
        int set = 0;
        
        if (italic)
	        set = 1;
	
        texture.select();

        //states
        glEnable(GL_BLEND);
        glDisable(GL_LIGHTING);
        glBlendFunc(GL_ONE, GL_ONE);
	glDisable(GL_DEPTH_TEST);						

        //set screen size
        glMatrixMode(GL_PROJECTION);						
	glPushMatrix();										
	glLoadIdentity();									
        glOrtho(0,640,0,480,-1,1);

        //go to modelview							
	glMatrixMode(GL_MODELVIEW);							
	glPushMatrix();										
	glLoadIdentity();									

        glTranslatef(x, y, 0.0f);								

        //set lisbase
        glListBase(lists - 32 + (128*set) );
        //draw text						
	glCallLists(strlen(text),GL_BYTE,text);

        //un-do changes
	glMatrixMode(GL_PROJECTION);						
	glPopMatrix();
        
	glMatrixMode(GL_MODELVIEW);							
	glPopMatrix();										

        //states
        glEnable(GL_DEPTH_TEST);
        glEnable(GL_LIGHTING);
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
        glDisable(GL_BLEND);
}
