// SBox1.h: Schnittstelle fr die Klasse SBox.
//
//////////////////////////////////////////////////////////////////////

#ifndef S_BOX_H
#define S_BOX_H

#include "sbmptexture.h"
#include "definition.h"

enum SBoxState 
{
DESTROYING,
NORMAL,
FALLING
};

class SBox  
{
public:
	SBox();
	virtual ~SBox();
        
	void update(float frametime);
	void init(SBMPTexture* tex);
	void draw();
        void moveBy(float x, float y);
        void setState(SBoxState state) { boxState = state; }
        void setPosition(float x, float y) { position[0]=x; position[1]=y;}
        bool touchesLeft() { return position[0] == 0.0f; }
        bool touchesRight() { return position[0] == FIELD_X-1; }
        bool touchesBottom() { return position[1] == 0.0f; }

        int posX() { return int(position[0]); }
        int posY() { return int(position[1]); }
        
	SBoxState getState() { return boxState; }
  
        bool touchesBoxes(SDirection pos);
        static void build();
protected:
	SBMPTexture* texture;
        SBoxState boxState;
	float position[2];   	
	int field[2];
        static unsigned int object;
};

#endif 