/***************************************************************************
                          sconfiguration.cpp  -  description
                             -------------------
    begin                : Mon Dec 30 2002
    copyright            : (C) 2002 by Andre Stein
    email                : andre_stein@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "sconfiguration.h"
#include <fstream.h>

/** 
  Helper functions for Windoze (Visual C++) as
  the outdated Microsoft C++ library seems to be
  unable to read/write bools. It's a standard but who cares,
  right Bill?
 **/
#ifdef WIN32

inline istream& operator >> (istream& stream, bool& value)
{
	int load;
	stream >> load;
	value = bool(load);
	return stream;
}

#endif

SConfiguration::SConfiguration()
{
        defaultConfig();
}

SConfiguration::~SConfiguration()
{
}

/** No descriptions */
void SConfiguration::defaultConfig()
{
        //set everything to true
        fullscreen = music = reflection = snowFlakes = true;
}

/** No descriptions */
void SConfiguration::load(const char* filename)
{
        ifstream file(filename, ios::in);

        if (file.good())
        {
                file >> fullscreen >> music >> reflection >> snowFlakes;
        }
}

/** No descriptions */
void SConfiguration::save(const char* filename)
{
        ofstream file(filename, ios::out);

        if (file.good())
        {
                file << fullscreen << " " << music << " "
                     << reflection << " " << snowFlakes;
        }
}
