/***************************************************************************
                          screditsscreen.cpp  -  description
                             -------------------
    begin                : Sun Dec 29 2002
    copyright            : (C) 2002 by Andre Stein
    email                : andre_stein@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "screditsscreen.h"
#include "definition.h"
#include <math.h>

#define X 100.0f
#define X2 150.0f
#define LINE_HEIGHT 16.0f
#define MAX_HEIGHT 800.0f


SCreditsScreen::SCreditsScreen()
{
        font = 0;
        /* begin at top */
        reset();
}

SCreditsScreen::~SCreditsScreen()
{
}

/** No descriptions */
void SCreditsScreen::update(float frametime)
{
        position += frametime * CREDITS_ROLL_SPEED;

        if (position >= MAX_HEIGHT)
        {
                position = 0.0f;
        }

        /* draw it! */
        draw();
}

/** No descriptions */
void SCreditsScreen::draw()
{
        int roll = floor(position);

        /**
          The Christmas Tetris
          Copyright(C) 2003 by SteinSOFT

          Lead Programmer
             Andr Stein
          Graphics
             Andr Stein
          Sound
             Jingle Bells by

          Special Thanks to
             Svenni & Sandra for extensive testing
             slyzer for very constructive critics...

          Visit www.steinsoft.net.
              Have fun.   
          **/

         //Standard help menu.. 
         font->printAt(550,10,"ESC",true);
         font->printAt(590,10,"Back");

         //Ok let's start..

         glColor3f(1.0f,0.0f,0.0f);
         font->printAt(X,roll,"The Christmas Tetris");

         glColor3f(1.0f,1.0f,1.0f);
         font->printAt(X,roll-LINE_HEIGHT,"Copyright(C) 2003 by SteinSOFT");

         font->printAt(X,roll-3*LINE_HEIGHT,"Lead programmer");
                font->printAt(X2,roll-4*LINE_HEIGHT,"Andre Stein", true);
         font->printAt(X,roll-5*LINE_HEIGHT,"Graphics");
                font->printAt(X2,roll-6*LINE_HEIGHT,"Andre Stein", true);
         font->printAt(X,roll-7*LINE_HEIGHT,"Sound");
                font->printAt(X2,roll-8*LINE_HEIGHT,"Jingle Bells by ???",true);
                font->printAt(X2,roll-9*LINE_HEIGHT,"Rudolph by ???", true);

         font->printAt(X, roll-11*LINE_HEIGHT,"Special thanks to");
                font->printAt(X2,roll-12*LINE_HEIGHT,"Svenni & Sandra for extensive testing",true);
                font->printAt(X2,roll-13*LINE_HEIGHT,"slyzer -- http://slysoft.de", true);
                font->printAt(X2,roll-14*LINE_HEIGHT," ... many other but I am too lazy :-)",true);

         font->printAt(X, roll-16*LINE_HEIGHT,"Visit steinsoft.net");
                font->printAt(X2,roll-17*LINE_HEIGHT,"Have fun!",true);
                
}

/** No descriptions */
void SCreditsScreen::reset()
{
        position = -LINE_HEIGHT;
}
