/***************************************************************************
                          sgamefield.h  -  description
                             -------------------
    begin                : Sun Dec 22 2002
    copyright            : (C) 2002 by Andre Stein
    email                : andre_stein@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SGAMEFIELD_H
#define SGAMEFIELD_H

#include "sbrick.h"
#include "definition.h"
#include "sconfiguration.h"
#include <vector>
#include <SDL.h>

using namespace std;

/**
  *@author Andre Stein
  */


class SGamefield
{
public: 
	SGamefield();
	~SGamefield();

        void init(SConfiguration* config);
        void reset();
        void update(float timeOfFrame);
        void moveDown();
        void moveRight();
        void moveLeft();
        void changeForm();
        void newBrick();
        void timerEvent();
        
        unsigned int getScore() { return score; }
        int getLevel() { return level; }
        int getRemovedLines() { return removedLines; }
        SBrick getNextBrick() { SBrick brick; brick.create(nextBrick, textures); return brick; }

        bool isGameOver();
        void pause();
        bool isPaused() const { return paused; }

        static bool field[FIELD_X][FIELD_Y];
protected:
        bool cantMove;
        vector<SBox> boxes;
        SBMPTexture textures[BRICK_NUM];
        SBrick current;
        SBrickType nextBrick;
        SConfiguration* configFile;
        SDL_TimerID timerID;
        int level;
        unsigned int score;
        int removedLines;
        unsigned int sidesObject;
        unsigned int mirrorObject;
        float frametime;
        bool paused;

        void draw();
        void finishRound();
        void destroyRows();
        void updateField();
        void drawField();

};

#endif
