/***************************************************************************
                          sglwindow.h  -  description
                             -------------------
    begin                : Wed Jan 23 2002
    copyright            : (C) 2002 by Andre Stein
    email                : andre_stein@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SGLWINDOW_H
#define SGLWINDOW_H

#ifdef WIN32
        #include <windows.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>
#include <SDL.h>

#include "sfadelogo.h"
#include "ssnowflakes.h"
#include "ssoundsystem.h"
#include "sgamefield.h"
#include "sendscene.h"
#include "sbmpfont.h"
#include "smenu.h"
#include "sconfiguration.h"
#include "shighscorelist.h"
#include "sinputdialog.h"
#include "screditsscreen.h"

/**
  *@author Andre Stein
  */

class SGLWindow
{
public: 
	SGLWindow();
	~SGLWindow();
	
	void resize(int width, int height);
	void init(SConfiguration* config, SDL_Surface* screen);
	void update(float frametime);
 	void keyDown(int key);
protected:
        SFadeLogo steinsoftLogo;
        SFadeLogo presentsLogo;
        SFadeLogo gameLogo;
        SSnowflakes snowFlakes;
        SGameState gameState;
        SSoundSystem soundSystem;
        SGamefield gamefield;
        SEndScene endScene;
        SBMPFont font;
        SInputDialog inputDialog;
        SCreditsScreen credits;
        SMenu menu;
        SHighscoreList highscoreList;
        SConfiguration* configFile;
        SDL_Surface* mainSurface;
};

#endif
