/***************************************************************************
                          ssoundsystem.cpp  -  description
                             -------------------
    begin                : Sun Dec 22 2002
    copyright            : (C) 2002 by Andre Stein
    email                : andre_stein@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ssoundsystem.h"

SSoundSystem::SSoundSystem()
{
        inited = false;
}

SSoundSystem::~SSoundSystem()
{
        if (inited)
                FSOUND_Close();
}

/** No descriptions */
void SSoundSystem::init()
{
        //init sound system
        FSOUND_Init(44100, 64, 0);

        //load mp3 samples
        merryChristmas = FSOUND_Stream_OpenFile(
                        "data/merry_christmas.mp3",0,0);
        background = FSOUND_Stream_OpenFile("data/background.mp3",
                FSOUND_LOOP_NORMAL,0);

        //yes we inited it!
        inited = true;
}

/** No descriptions */
void SSoundSystem::playSample(SSample sample)
{
        switch (sample)
        {
        case SAMPLE_MERRYCHRISTMAS:
                FSOUND_Stream_Play(FSOUND_FREE, merryChristmas);
                break;
        case SAMPLE_BACKGROUND:
                FSOUND_Stream_Play(FSOUND_FREE, background);
                break;
        default:
                break;
        }
}

/** No descriptions */
void SSoundSystem::stopAll()
{
        FSOUND_StopSound(FSOUND_ALL);
}
